
(function($){
var server=APP_PATH+"statics/update/update.json",//获取升级描述文件服务器地址
localDir="update",//本地保存升级描述目录和文件名
keyUpdate="updateCheck",//取消升级键名
//checkInterval=86400000,//升级检查间隔，单位为ms,7天为7*24*60*60*1000=604800000, 如果每次启动需要检查设置值为0
checkInterval=0,
dir=null;

/**
 * 准备升级操作
 * 创建升级文件保存目录
 */
$.initUpdate = function(callback){
	// 打开doc根目录
	plus.io.requestFileSystem( plus.io.PRIVATE_DOC, function(fs){
		fs.root.getDirectory( localDir, {create:true}, function(entry){
			dir = entry;
			getUpdateData(callback);
		}, function(e){
			console.log( "准备升级操作，打开update目录失败："+e.message );
		});
	},function(e){
		console.log( "准备升级操作，打开doc目录失败："+e.message );
	});
}

/**
 * 检查升级数据
 */
function checkUpdateData( j,callback ){
	var curVer=plus.runtime.version,
	inf = j[plus.os.name];
	if ( inf ){
		var srvVer = inf.version;
		// 判断是否需要升级
		plus.nativeUI.closeWaiting();
		if ( compareVersion(curVer,srvVer) ) {
			plus.storage.setItem('srvVer', srvVer);
			// 提示用户是否升级
			plus.nativeUI.confirm( inf.note, function(i){
				if ( 0==i.index ) {
					if(plus.os.name==='Android'){
						createDownload(inf.url);
					}else{
						plus.runtime.openURL( inf.url );
					}
				} else {
					plus.storage.setItem( keyUpdate, (new Date()).getTime().toString() );
				}
			}, inf.title, ["立即更新","取消"] );
		}else{
			if (callback) callback();
			plus.storage.removeItem( 'srvVer' );
		}
	}
}

/**
 * 从服务器获取升级数据
 */
function getUpdateData(callback){
	// 判断升级检测是否过期
	var lastcheck = plus.storage.getItem( keyUpdate );
	if ( lastcheck ) {
		var dc = parseInt( lastcheck );
		var dn = (new Date()).getTime();
		if ( dn-dc < checkInterval ) {	// 未超过上次升级检测间隔，不需要进行升级检查
			return;
		}
		// 取消已过期，删除取消标记
		plus.storage.removeItem( keyUpdate );
	}
	var xhr = new plus.net.XMLHttpRequest();
	xhr.onreadystatechange = function () {
        switch ( xhr.readyState ) {
            case 4:
                if ( xhr.status == 200 ) {
                	// 保存到本地文件中
                	checkUpdateData(JSON.parse(xhr.responseText),callback);
                } else {
                	console.log( "获取升级数据，联网请求失败："+xhr.status );
                }
                break;
            default :
                break;
        }
	}
	xhr.open( "GET", server );
	xhr.send();
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false,
	ova = ov.split(".",4),
	nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
}
// 创建下载任务
    function createDownload(apk_dir) {
        apk_dir = encodeURI(apk_dir);
        var dtask = plus.downloader.createDownload( apk_dir, {}, function ( d, status ) {
            // 下载完成
            if ( status == 200 ) { 
                console.log( "Download success: " + d.filename );
                installApp(d.filename);
            } else {
                console.log( "Download failed: " + status ); 
            }  
        });
        var w=plus.nativeUI.showWaiting("　　 开始下载...　　 ");
        dtask.addEventListener( "statechanged", function(task,status){
            switch(task.state) {
                case 1: // 开始
                    w.setTitle("　　 开始下载...　　 ");
                break;
                case 2: // 已连接到服务器
                    w.setTitle("　　 开始下载...　　 ");
                break;
                case 3:
                    var a = task.downloadedSize/task.totalSize*100;
                    w.setTitle("　　 已下载"+parseInt(a)+"%　　 ");
                break;
                case 4: // 下载完成
                    w.close();
                break;
            }
        } );
        dtask.start(); 
    }

    //安装软件
    function installApp(install_dir){
        plus.runtime.install( install_dir, {}, function(){
            console.info("install success !");
            plus.runtime.quit();
        }, function(){
            console.info("install error !");
        });
    }

})(mui);
