/**
 * jQuery photoClip v1.4
 * 依赖插件
 * - iscroll-zoom.js
 * - hammer.js
 * @brief	支持手势的裁图插件
 *			在移动设备上双指捏合为缩放，双指旋转可根据旋转方向每次旋转90度
 *			在PC设备上鼠标滚轮为缩放，每次双击则顺时针旋转90度
 * @option_param {number} width 截取部分的宽度
 * @option_param {number} height 截取部分的高度
 * @option_param {string} file 上传图片的<input type="file">控件的选择器或者DOM对象
 * @option_param {string} view 显示截取后图像的容器的选择器或者DOM对象
 * @option_param {string} ok 确认截图按钮的选择器或者DOM对象
 * @option_param {boolean} strictSize 是否严格按照截取宽高裁剪。默认为false，表示截取宽高仅用于约束宽高比例。如果设置为true，则表示截取出的图像宽高严格按照截取宽高输出
 * @option_param {function} loadStart 开始加载的回调函数。this指向 fileReader 对象，并将正在加载的 file 对象作为参数传入
 * @option_param {function} loadComplete 加载完成的回调函数。this指向图片对象，并将图片地址作为参数传入
 * @option_param {function} loadError 加载失败的回调函数。this指向 fileReader 对象，并将错误事件的 event 对象作为参数传入
 * @option_param {function} clipFinish 裁剪完成的回调函数。this指向图片对象，会将裁剪出的图像数据DataURL作为参数传入
 */
(function(d){d.fn.photoClip=function(f){if(!window.FileReader){alert("您的浏览器不支持 HTML5 的 FileReader API， 因此无法初始化图片裁剪插件，请更换最新的浏览器！");return}var e={width:180,height:180,file:"",view:"",ok:"",strictSize:false,loadStart:function(){},loadComplete:function(){},loadError:function(){},clipFinish:function(){}};d.extend(e,f);this.each(function(){b(this,e)});return this};function b(N,P){var z=P.width,J=P.height,x=P.file,i=P.view,M=P.ok,Z=P.strictSize,R=P.loadStart,t=P.loadComplete,U=P.loadError,S=P.clipFinish;var ae,y,h,I;plus.io.resolveLocalFileSystemURL(x,function(af){af.file(function(ah){var ag=new plus.io.FileReader();ag.onloadend=function(ai){var ak=ah.size/1024;console.log(ah.size);console.log(ak);if(ak>1024){var al=1024/ak;var aj=d("<img>").hide();aj.load(function(){var an=this.naturalWidth;aj.appendTo(document.body);var ap=this.naturalHeight;aj.remove();delete aj[0];aj=null;var am=0;if(an==ap){am=90}var ao=D(this,al,am);f(ao)});aj.attr("src",ai.target.result)}else{f(ai.target.result)}};ag.readAsDataURL(ah,"utf-8");R.call(ag,ah)})},function(af){alert("Resolve file URL failed: "+af.message)});var m,T,Y,E,q,o,l,u,X;W();B();p();C();var A=d(M);if(A.length){A.click(function(){d(".lazy_cover,.lazy_tip").show();k()})}var H=d(window);w();H.resize(w);var O,ad,ab,e;function ac(){I=true;E.append(this);aa.call(this,ae,function(){y=this.naturalWidth;h=this.naturalHeight});aa(Y,function(){r()});t.call(this,this.src)}function B(){var af={zoom:true,scrollX:true,scrollY:true,freeScroll:true,mouseWheel:true,wheelAction:"zoom"};l=new IScroll(T[0],af)}function r(){ad=0;ab=0;e=0;E.css({width:y,height:h});j(E,ad,ab,e);v(y,h);l.zoom(l.options.zoomStart);n(y,h);var ag=(z-y*l.options.zoomStart)*0.5,af=(J-h*l.options.zoomStart)*0.5;l.scrollTo(ag,af)}function n(ag,af){Y.css({width:ag,height:af});T.append(Y);l.refresh()}function p(){var af=new Hammer(Y[0]);af.add(new Hammer.Rotate());var ag,ah;af.on("rotatemove",function(ai){if(O){return}ag=ai.rotation;if(ag>180){ag-=360}else{if(ag<-180){ag+=360}}ah=ag>0?1:ag<0?-1:0});af.on("rotateend",function(ai){if(O){return}if(Math.abs(ag)>30){if(ah==1){L(ai.center)}else{if(ah==-1){Q(ai.center)}}}})}function L(af){K(90,af)}function Q(af){K(-90,af)}function K(ag,am){if(O){return}O=true;var ak;if(!am){ak=g(Y,T,z*0.5,J*0.5)}else{ak=G(Y,am.x,am.y)}var al=V(e,ak),ar=al.x,aq=al.y,ai=0,ah=0,ap=0,ao=0,aj=e+ag,af,an;if(aj==90||aj==-270){ai=ar+aq;ah=aq-ar;if(aj>e){ap=h-ar-aq;ao=ar-aq}else{if(aj<e){ap=(h-aq)-(y-ar);ao=ar+aq-h}}af=h;an=y}else{if(aj==180||aj==-180){ai=ar*2;ah=aq*2;if(aj>e){ap=(y-ar)-(h-aq);ao=h-(ar+aq)}else{if(aj<e){ap=y-(ar+aq);ao=(h-aq)-(y-ar)}}af=y;an=h}else{if(aj==270||aj==-90){ai=ar-aq;ah=ar+aq;if(aj>e){ap=ar+aq-y;ao=(y-ar)-(h-aq)}else{if(aj<e){ap=aq-ar;ao=y-ar-aq}}af=h;an=y}else{if(aj==0||aj==360||aj==-360){ai=0;ah=0;if(aj>e){ap=ar-aq;ao=ar+aq-y}else{if(aj<e){ap=ar+aq-h;ao=aq-ar}}af=y;an=h}}}}if(e==0){ad=0;ab=0}else{if(e==90||e==-270){ad-=ar+aq;ab-=aq-ar}else{if(e==180||e==-180){ad-=ar*2;ab-=aq*2}else{if(e==270||e==-90){ad-=ar-aq;ab-=ar+aq}}}}ad=ad.toFixed(2)-0;ab=ab.toFixed(2)-0;j(E,ad,ab,e,ar,aq);s(E,ad,ab,aj,200,function(){O=false;e=aj%360;ad+=ai+ap;ab+=ah+ao;ad=ad.toFixed(2)-0;ab=ab.toFixed(2)-0;j(E,ad,ab,e);l.scrollTo(l.x-ap*l.scale,l.y-ao*l.scale);v(af,an);if(l.scale<l.options.zoomMin){l.zoom(l.options.zoomMin)}n(af,an)})}function C(){o=document.createElement("canvas");o.width=z;o.height=J}function k(){if(!I){alert("当前没有图片可以裁剪!");return}var ag=g(Y,T);var ai=l.scale;var af=o.getContext("2d");af.clearRect(0,0,o.width,o.height);af.save();if(Z){af.scale(ai,ai)}else{o.width=z/ai;o.height=J/ai}af.translate(ad-ag.x/ai,ab-ag.y/ai);af.rotate(e*Math.PI/180);af.drawImage(ae[0],0,0);af.restore();var ah=o.toDataURL("image/jpeg");q.css("background-image","url("+ah+")");S.call(ae[0],ah)}function w(){aa(m,function(){u=m.width();X=m.height()})}function g(ai,ah,ag,ak){ag=ag||0;ak=ak||0;var af,aj;aa(ai,function(){af=ai.offset()});aa(ah,function(){aj=ah.offset()});return{x:aj.left-af.left+ag,y:aj.top-af.top+ak}}function G(ag,af,ai){af=af||0;ai=ai||0;var ah;aa(ag,function(){ah=ag.offset()});return{x:af+H.scrollLeft()-ah.left,y:ai+H.scrollTop()-ah.top}}function aa(ah,ag){var af=d();d.each(ah,function(aj,am){var ak=d(am);var al=ak.parents().andSelf().filter(":hidden");var ai;for(var aj=0;aj<al.length;aj++){if(!ak.is(":hidden")){break}ai=al.eq(aj);if(ai.css("display")=="none"){af=af.add(ai.show())}}});if(typeof(ag)=="function"){ag.call(this)}af.hide()}function V(ai,af){var ah=l.scale;var ag={};if(ai==0){ag.x=af.x/ah;ag.y=af.y/ah}else{if(ai==90||ai==-270){ag.x=af.y/ah;ag.y=h-af.x/ah}else{if(ai==180||ai==-180){ag.x=y-af.x/ah;ag.y=h-af.y/ah}else{if(ai==270||ai==-90){ag.x=y-af.y/ah;ag.y=af.x/ah}}}}return ag}function F(ag,ai,af,ah){var ak=ag/af;var aj=ai/ah;return ak>aj?ak:aj}function v(ag,af){l.options.zoomMin=F(z,J,ag,af);l.options.zoomMax=Math.max(1,l.options.zoomMin);l.options.zoomStart=Math.min(l.options.zoomMax,F(u,X,ag,af))}function D(al,an,ag,ak){an=an||0.8;ag=ag||0;var af="image/jpeg";if(ak!=undefined&&ak=="png"){af="image/png"}var ap=al.naturalWidth,aj=al.naturalHeight;var ai=Math.max(ap,aj);if(ai>1024){var am=Math.min(ap,aj);am=am/ai*1024;ai=1024;if(ap>aj){ap=ai;aj=am}else{ap=am;aj=ai}}var ah=document.createElement("canvas");var ao=ah.getContext("2d");if(ag){ah.width=aj;ah.height=ap;ao.translate(aj,0);ao.rotate(ag*Math.PI/180)}else{ah.width=ap;ah.height=aj}ao.drawImage(al,0,0,ap,aj);var aq=ah.toDataURL(af,an||0.8);return aq}function f(af){if(ae&&ae.length){ae.remove();delete ae[0]}ae=d("<img>").css({"user-select":"none","pointer-events":"none"});ae.load(ac);ae.attr("src",af)}function j(al,af,ak,aj,ah,ag){ah=ah||0;ag=ag||0;var ai={};ai[c+"transform"]="translateZ(0) translate("+af+"px,"+ak+"px) rotate("+aj+"deg)";ai[c+"transform-origin"]=ah+"px "+ag+"px";al.css(ai)}function s(ak,af,aj,ai,ah,ag){ak.css(c+"transform");ak.css(c+"transition",c+"transform "+ah+"ms");ak.one(a,function(){ak.css(c+"transition","");ag.call(this)});ak.css(c+"transform","translateZ(0) translate("+af+"px,"+aj+"px) rotate("+ai+"deg)")}function W(){m=d(N).css({"user-select":"none",overflow:"hidden"});if(m.css("position")=="static"){m.css("position","relative")}T=d("<div class='photo-clip-view'>").css({position:"absolute",left:"50%",top:"50%",width:z,height:J,"margin-left":-z/2,"margin-top":-J/2}).appendTo(m);Y=d("<div class='photo-clip-moveLayer'>").appendTo(T);E=d("<div class='photo-clip-rotateLayer'>").appendTo(Y);var aj=d("<div class='photo-clip-mask'>").css({position:"absolute",left:0,top:0,width:"100%",height:"100%","pointer-events":"none"}).appendTo(m);var ag=d("<div class='photo-clip-mask-left'>").css({position:"absolute",left:0,right:"50%",top:"50%",bottom:"50%",width:"auto",height:J,"margin-right":z/2,"margin-top":-J/2,"margin-bottom":-J/2,"background-color":"rgba(0,0,0,.5)"}).appendTo(aj);var ai=d("<div class='photo-clip-mask-right'>").css({position:"absolute",left:"50%",right:0,top:"50%",bottom:"50%","margin-left":z/2,"margin-top":-J/2,"margin-bottom":-J/2,"background-color":"rgba(0,0,0,.5)"}).appendTo(aj);var ak=d("<div class='photo-clip-mask-top'>").css({position:"absolute",left:0,right:0,top:0,bottom:"50%","margin-bottom":J/2,"background-color":"rgba(0,0,0,.5)"}).appendTo(aj);var ah=d("<div class='photo-clip-mask-bottom'>").css({position:"absolute",left:0,right:0,top:"50%",bottom:0,"margin-top":J/2,"background-color":"rgba(0,0,0,.5)"}).appendTo(aj);var af=d("<div class='photo-clip-area'>").css({border:"1px dashed #ddd",position:"absolute",left:"50%",top:"50%",width:z,height:J,"margin-left":-z/2-1,"margin-top":-J/2-1}).appendTo(aj);q=d(i);if(q.length){q.css({"background-color":"#666","background-repeat":"no-repeat","background-position":"center","background-size":"contain"})}}}var c="",a;(function(){var g,j={Webkit:"webkit",Moz:"",O:"o"},h=document.documentElement,e=function(i){return g?g+i:i.toLowerCase()};for(var f in j){if(h.style[f+"TransitionProperty"]!==undefined){c="-"+f.toLowerCase()+"-";g=j[f];break}}a=e("TransitionEnd")})()})(jQuery);
